.NH
Future Work
.PP
We need to upgrade wrappy for Python 1.5.2
because Python 1.5.2 is a major improvement as a target for wrapper generators.
It has extensive error checks for unimplemented number methods,
so a Python type may implement only a subset of them.
It also has a new N format for Py_BuildValue that returns a Python object
without incrementing its reference count
\(em a feature that we are already using.
And the major change in Python 1.5.2,
where Python class methods can be C functions,
will enable us stop using the Extension Class extension.
Being able to use Python classes for C++ classes means
that we should revisit the design decision to use Python types
(we should probably switch to using Python classes,
but C++ classes that overload number methods or sequence methods
might stay types). 
.PP
There are other C++ features wrappy should support.
It should be possible to support:
.ID
\(bu alternative smart pointer mechanisms
\(bu global variables
\(bu template base classes
\(bu explicitly instantiated template classes
\(bu callback functions written in Python
.DE
These will be added as we need them.
.NH
Conclusion
.PP
Wrappy provides better support for standard C++ than SWIG and PYFFLE.
Now, we can easily build new molecular modeling tools
and get the speed we want.
Python is used for the user interface, scripting,
and writing modeling extensions.
Anything speed critical can be rewritten in C++
and easily reintegrated into Python via a wrappy-generated extension.
.PP
Further information and source code can be found on the Internet at
http://www.cgl.ucsf.edu/\%Research/\%otf/\%wrappy/.
